- block:
  - include_role:
      name: commons
      tasks_from: helpers/volume.yaml
    vars:
      vol_name: "{{ db_host }}-{{ snap_mark | default('default') }}-snap"
      vol_size: "{{ db_data_capacity }}"
  - name: Marks operation in progress
    set_fact:
      snap_failed: True
    when:
    - has_pvc is defined
    - has_pvc.resources is defined
    - (has_pvc.resources | length) > 0
  when:
  - provision_volume | default(True)
- include_role:
    name: commons
    tasks_from: helpers/job.yaml
  vars:
    job_args: |
      echo "Starting snapshot on $(date +%s)";
      if test "$DEBUG"; then
          set -x;
      fi;
      cpt=0;
      while test "$cpt" -lt 10; do
          if pg_dump -U "$POSTGRES_USER" -h "$POSTGRES_HOST" -p 5432 "$POSTGRES_DB" >"/backup/$POSTGRES_DB.sql"; then
              break;
          fi;
          cpt=$(expr $cpt + 1);
          sleep 10;
      done;
      if test "$cpt" -ge 10; then
          echo failed snapshotting database;
      elif test -s "/backup/$POSTGRES_DB.sql"; then
          echo "successfully backed up postgres:$POSTGRES_HOST:$POSTGRES_DB on $(date +%s)";
          exit 0;
      else
          echo empty backup - WARNING;
      fi;
      echo "Failed on $(date +%s)";
      exit 1;
    job_env:
    - name: DEBUG
      value: "{{ 'yes' if (do_debugs) else '' }}"
    - name: PGPASSWORD
      secret_key: database-password
      secret_name: "{{ db_secret_name }}"
    - name: POSTGRES_DB
      secret_key: database-name
      secret_name: "{{ db_secret_name }}"
    - name: POSTGRES_HOST
      value: "{{ db_host }}"
    - name: POSTGRES_USER
      secret_key: database-user
      secret_name: "{{ db_secret_name }}"
    job_image: "{{ (opsimages | json_query(\"[?name=='backups'].image\"))[0] }}"
    job_name: "{{ db_host }}-{{ snap_mark | default('default') }}-snap"
    job_volumes:
    - kind: PersistentVolumeClaim
      name: "{{ db_host }}-{{ snap_mark | default('default') }}-snap"
      path: /backup
  when:
  - (snap_failed | default(False)) == False
- include_role:
    name: commons
    tasks_from: helpers/wait-for.yaml
  vars:
    check_with: "{{ lookup('k8s', api_version='batch/v1', kind='Job',
                           resource_name=(db_host ~ '-' ~ (snap_mark | default('default')) ~ '-snap'),
                           namespace=namespace) | default('') }}"
    obj_name: "{{ db_host }}-{{ snap_mark | default('default') }}-snap"
    retries_for: "{{ (snap_wait_retries | default(60)) | int }}"
    wait_for: "{{ (snap_wait_for | default(10)) | int }}"
  when:
  - (snap_failed | default(False)) == False
  - job_wait_completion | default(True)
